diff --git a/src/teamd.c b/src/teamd.c
index 0a5d0a0ed..25ed3d956 100644
--- a/src/teamd.c
+++ b/src/teamd.c
@@ -1,7 +1,7 @@
 /*
  *	Interfacing with teamd through dbus interface
  *
- *	Copyright (C) 2015 SUSE Linux GmbH, Nuernberg, Germany.
+ *	Copyright (C) 2015-2023 SUSE LLC
  *
  *	This program is free software; you can redistribute it and/or modify
  *	it under the terms of the GNU General Public License as published by
@@ -13,14 +13,8 @@
  *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *	GNU General Public License for more details.
  *
- *	You should have received a copy of the GNU General Public License along
- *	with this program; if not, see <http://www.gnu.org/licenses/> or write
- *	to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
- *	Boston, MA 02110-1301 USA.
- *
- *	Authors:
- *		Pawel Wieczorkiewicz <pwieczorkiewicz@suse.de>
- *		Marius Tomaschewski <mt@suse.de>
+ *	You should have received a copy of the GNU General Public License
+ *	along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
 #ifdef HAVE_CONFIG_H
 #include "config.h"
@@ -69,6 +63,7 @@
 #define NI_TEAMD_CALL_PORT_ADD			"PortAdd"
 #define NI_TEAMD_CALL_PORT_REMOVE		"PortRemove"
 #define NI_TEAMD_CALL_PORT_CONFIG_UPDATE	"PortConfigUpdate"
+#define NI_TEAMD_CALL_PORT_CONFIG_DUMP		"PortConfigDump"
 
 
 typedef struct ni_teamd_client_ops {
@@ -80,6 +75,7 @@ typedef struct ni_teamd_client_ops {
 	int	(*ctl_port_add)(ni_teamd_client_t *, const char *);
 	int	(*ctl_port_remove)(ni_teamd_client_t *, const char *);
 	int	(*ctl_port_config_update)(ni_teamd_client_t *, const char *, const char *);
+	int	(*ctl_port_config_dump)(ni_teamd_client_t *, const char *, char **);
 } ni_teamd_client_ops_t;
 
 struct ni_teamd_client {
@@ -329,7 +325,7 @@ ni_teamd_dbus_ctl_port_config_update(ni_teamd_client_t *tdc, const char *port_na
 	int rv = 0;
 
 	if (ni_string_empty(port_name))
-		return FALSE;
+		return -NI_ERROR_INVALID_ARGS;
 
 	dbus_error_init(&error);
 	call = ni_dbus_object_call_new(tdc->proxy, NI_TEAMD_CALL_PORT_CONFIG_UPDATE, 0);
@@ -350,6 +346,27 @@ ni_teamd_dbus_ctl_port_config_update(ni_teamd_client_t *tdc, const char *port_na
 	return rv;
 }
 
+static int
+ni_teamd_dbus_ctl_port_config_dump(ni_teamd_client_t *tdc, const char *port_name, char **result)
+{
+	int rv = 0;
+
+	if (ni_string_empty(port_name))
+		return -NI_ERROR_INVALID_ARGS;
+
+	ni_string_free(result);
+	rv = ni_dbus_object_call_simple(tdc->proxy,
+		NI_TEAMD_INTERFACE, NI_TEAMD_CALL_PORT_CONFIG_DUMP,
+		DBUS_TYPE_STRING, &port_name,
+		DBUS_TYPE_STRING, result);
+
+	if (rv < 0) {
+		ni_debug_application("Call to %s."NI_TEAMD_CALL_PORT_CONFIG_DUMP"(%s) failed: %s",
+				ni_dbus_object_get_path(tdc->proxy), port_name, ni_strerror(rv));
+	}
+	return rv;
+}
+
 /*
  * === unix client ===
  */
@@ -408,7 +425,7 @@ ni_teamd_unix_ctl_config_dump(ni_teamd_client_t *tdc, ni_bool_t actual, char **r
 	int rv;
 
 	if (!result)
-		return -1;
+		return -NI_ERROR_INVALID_ARGS;
 
 	ni_buffer_init_dynamic(&buf, 1024);
 	if (!(pi = ni_process_new(tdc->cmd)))
@@ -421,7 +438,7 @@ ni_teamd_unix_ctl_config_dump(ni_teamd_client_t *tdc, ni_bool_t actual, char **r
 
 	rv = ni_process_run_and_capture_output(pi, &buf);
 	ni_process_free(pi);
-	if (rv) {
+	if (rv != NI_PROCESS_SUCCESS) {
 		ni_error("%s: unable to dump team config", tdc->instance);
 		goto failure;
 	}
@@ -456,7 +473,7 @@ ni_teamd_unix_ctl_port_add(ni_teamd_client_t *tdc, const char *port_name)
 
 	rv = ni_process_run_and_wait(pi);
 	ni_process_free(pi);
-	if (rv) {
+	if (rv != NI_PROCESS_SUCCESS) {
 		ni_error("%s: unable to add team port %s", tdc->instance, port_name);
 		return -1;
 	}
@@ -481,7 +498,7 @@ ni_teamd_unix_ctl_port_remove(ni_teamd_client_t *tdc, const char *port_name)
 
 	rv = ni_process_run_and_wait(pi);
 	ni_process_free(pi);
-	if (rv) {
+	if (rv != NI_PROCESS_SUCCESS) {
 		ni_error("%s: unable to remove team port %s", tdc->instance, port_name);
 		return -1;
 	}
@@ -508,13 +525,51 @@ ni_teamd_unix_ctl_port_config_update(ni_teamd_client_t *tdc, const char *port_na
 
 	rv = ni_process_run_and_wait(pi);
 	ni_process_free(pi);
-	if (rv) {
+	if (rv != NI_PROCESS_SUCCESS) {
 		ni_error("%s: unable to update team port %s config", tdc->instance, port_name);
 		return -1;
 	}
 	return 0;
 }
 
+int
+ni_teamd_unix_ctl_port_config_dump(ni_teamd_client_t *tdc, const char *port_name, char **result)
+{
+	ni_process_t *pi;
+	ni_buffer_t buf;
+	int rv;
+
+	if (!tdc || ni_string_empty(port_name) || !result)
+		return -1;
+
+	ni_buffer_init_dynamic(&buf, 1024);
+	if (!(pi = ni_process_new(tdc->cmd)))
+		goto failure;
+
+	ni_string_array_append(&pi->argv, "port");
+	ni_string_array_append(&pi->argv, "config");
+	ni_string_array_append(&pi->argv, "dump");
+	ni_string_array_append(&pi->argv, port_name);
+
+	rv = ni_process_run_and_capture_output(pi, &buf);
+	ni_process_free(pi);
+	if (rv != NI_PROCESS_SUCCESS) {
+		ni_error("%s: unable to update team port %s config", tdc->instance, port_name);
+		goto failure;
+	}
+
+	ni_buffer_put(&buf, "\0", 1);
+	ni_string_free(result);
+	*result = (char *)buf.base;
+	buf.base = NULL;
+	ni_buffer_destroy(&buf);
+	return 0;
+
+failure:
+	ni_buffer_destroy(&buf);
+	return -1;
+}
+
 /*
  *  === teamd client ===
  */
@@ -527,6 +582,7 @@ static const ni_teamd_client_ops_t	teamd_dbus_ops = {
 	.ctl_port_add		= ni_teamd_dbus_ctl_port_add,
 	.ctl_port_remove	= ni_teamd_dbus_ctl_port_remove,
 	.ctl_port_config_update	= ni_teamd_dbus_ctl_port_config_update,
+	.ctl_port_config_dump	= ni_teamd_dbus_ctl_port_config_dump,
 };
 
 static const ni_teamd_client_ops_t	teamd_unix_ops = {
@@ -535,6 +591,7 @@ static const ni_teamd_client_ops_t	teamd_unix_ops = {
 	.ctl_port_add		= ni_teamd_unix_ctl_port_add,
 	.ctl_port_remove	= ni_teamd_unix_ctl_port_remove,
 	.ctl_port_config_update	= ni_teamd_unix_ctl_port_config_update,
+	.ctl_port_config_dump	= ni_teamd_unix_ctl_port_config_dump,
 };
 
 ni_bool_t
@@ -714,6 +771,14 @@ ni_teamd_ctl_port_config_update(ni_teamd_client_t *tdc, const char *port_name, c
 	return tdc->ops.ctl_port_config_update(tdc, port_name, port_conf);
 }
 
+int
+ni_teamd_ctl_port_config_dump(ni_teamd_client_t *tdc, const char *port_name, char **result)
+{
+	if (!tdc || !tdc->ops.ctl_port_config_dump)
+		return -1;
+	return tdc->ops.ctl_port_config_dump(tdc, port_name, result);
+}
+
 static ni_json_t *
 ni_teamd_port_config_json(const ni_team_port_config_t *config)
 {
@@ -792,9 +857,70 @@ failure:
 	return ret;
 }
 
+/*
+ * teamd port config discovery
+ */
+static inline int
+ni_teamd_port_config_parse_json(ni_team_port_config_t *conf, ni_json_t *object)
+{
+	int64_t i64;
+	ni_bool_t b;
+
+	if (!conf)
+		return -NI_ERROR_INVALID_ARGS;
+
+	if (!ni_json_is_object(object))
+		return 1; /* no/empty/null config from teamd */
+
+	if (ni_json_int64_get(ni_json_object_get_value(object, "queue_id"), &i64))
+		conf->queue_id = i64;
+
+	if (ni_json_int64_get(ni_json_object_get_value(object, "prio"), &i64))
+		conf->ab.prio = i64;
+	if (ni_json_bool_get(ni_json_object_get_value(object, "sticky"), &b))
+		conf->ab.sticky = b;
+
+	if (ni_json_int64_get(ni_json_object_get_value(object, "lacp_prio"), &i64))
+		conf->lacp.prio = i64;
+	if (ni_json_int64_get(ni_json_object_get_value(object, "lacp_key"), &i64))
+		conf->lacp.key = i64;
+
+	return 0;
+}
+
+extern int
+ni_teamd_port_config_discover(ni_team_port_config_t *conf,
+		const char *team, const char *name)
+{
+	ni_teamd_client_t *tdc = NULL;
+	ni_json_t *json = NULL;
+	char *jstr = NULL;
+	int rv = -1;
+
+	if (!conf || ni_string_empty(team) || ni_string_empty(name))
+		return -NI_ERROR_INVALID_ARGS;
+
+	if (!(tdc = ni_teamd_client_open(team)))
+		goto cleanup;
+
+	if (ni_teamd_ctl_port_config_dump(tdc, name, &jstr) < 0)
+		goto cleanup;
+
+	if (!(json = ni_json_parse_string(jstr)))
+		goto cleanup;
+
+	rv = ni_teamd_port_config_parse_json(conf, json);
+
+cleanup:
+	ni_teamd_client_free(tdc);
+	ni_string_free(&jstr);
+	ni_json_free(json);
+	return rv;
+}
 
 /*
- * teamd discovery
+ * team interface config discovery
+ * note: it's config, not state
  */
 static int
 ni_teamd_discover_runner(ni_team_t *team, ni_json_t *conf)
@@ -1048,76 +1174,6 @@ failure:
 	return -1;
 }
 
-static int
-ni_teamd_discover_port_details(ni_team_port_t *port, ni_json_t *details)
-{
-	int64_t i64;
-	ni_bool_t b;
-
-	if (!ni_json_is_object(details))
-		return 1;
-
-	if (ni_json_int64_get(ni_json_object_get_value(details, "queue_id"), &i64))
-		port->config.queue_id = i64;
-
-	if (ni_json_int64_get(ni_json_object_get_value(details, "prio"), &i64))
-		port->config.ab.prio = i64;
-	if (ni_json_bool_get(ni_json_object_get_value(details, "sticky"), &b))
-		port->config.ab.sticky = b;
-
-	if (ni_json_int64_get(ni_json_object_get_value(details, "lacp_prio"), &i64))
-		port->config.lacp.prio = i64;
-	if (ni_json_int64_get(ni_json_object_get_value(details, "lacp_key"), &i64))
-		port->config.lacp.key = i64;
-
-	return 0;
-}
-
-static int
-ni_teamd_discover_ports(ni_team_t *team, ni_json_t *conf)
-{
-	ni_team_port_t *port;
-	ni_json_t *ports;
-	unsigned int i, count;
-
-	if (!team || !conf)
-		return -1;
-
-	if (!(ports = ni_json_object_get_value(conf, "ports")))
-		return 0;
-
-	if (!ni_json_is_object(ports))
-		return 1;
-
-	count = ni_json_object_entries(ports);
-	for (i = 0; i < count; ++i) {
-		ni_json_pair_t *pair;
-		ni_json_t *details;
-		const char *name;
-
-		if (!(pair = ni_json_object_get_pair_at(ports, i)))
-			continue;
-
-		name = ni_json_pair_get_name(pair);
-		if (ni_string_empty(name))
-			continue;
-		port = ni_team_port_new();
-		ni_netdev_ref_set_ifname(&port->device, name);
-
-		details = ni_json_pair_get_value(pair);
-		if (ni_teamd_discover_port_details(port, details) < 0) {
-			ni_team_port_free(port);
-			continue;
-		}
-
-		if (!ni_team_port_array_append(&team->ports, port)) {
-			ni_team_port_free(port);
-			continue;
-		}
-	}
-	return 0;
-}
-
 static void
 ni_teamd_discover_notify_peers(ni_team_t *team, ni_json_t *conf)
 {
@@ -1190,9 +1246,6 @@ ni_teamd_discover(ni_netdev_t *dev)
 	if (ni_teamd_discover_link_watch(team, conf) < 0)
 		goto failure;
 
-	if (ni_teamd_discover_ports(team, conf) < 0)
-		goto failure;
-
 	ni_netdev_set_team(dev, team);
 	ni_teamd_client_free(tdc);
 	ni_json_free(conf);
@@ -1207,6 +1260,155 @@ failure:
 	return -1;
 }
 
+/*
+ * Discover port info from teamd state
+ *
+ * The teamdctl (dbus, unix) API does not provide separate
+ * PortStateDump (port state dump), but only a "StateDump"
+ * (state dump) containing both, teamd interface state and
+ * state for all ports.
+ *
+ * Currently, we discover only the runner and the overall
+ * link watches up/down summary state.
+ */
+static ni_bool_t
+ni_teamd_state_get_runner_type(ni_json_t *state, ni_team_runner_type_t *type)
+{
+	ni_json_t *setup = ni_json_object_get_value(state, "setup");
+	ni_json_t *runner = ni_json_object_get_value(setup, "runner_name");
+	char *name = NULL;
+	ni_bool_t ret;
+
+	ni_json_string_get(runner, &name);
+	ret = ni_team_runner_name_to_type(name, type);
+	ni_string_free(&name);
+	return ret;
+}
+
+static ni_json_t *
+ni_teamd_state_get_port_info(ni_json_t *state, const char *name)
+{
+	ni_json_t *ports = ni_json_object_get_value(state, "ports");
+
+	return ni_json_object_get_value(ports, name);
+}
+
+static int
+ni_teamd_state_port_runner_lacp_discover(ni_team_port_info_t *info, ni_json_t *runner)
+{
+	ni_team_port_runner_lacp_info_t *lacp = &info->runner.lacp;
+	ni_json_t *aggregator;
+	int64_t i64;
+
+	/*
+	 * See "3.7 Configuring LACP for 802.3ad mode in a more secure way"
+	 * described in linux-<version>/Documentation/networking/bonding.rst.
+	 * Take care to not expose lacp system mac,key,prio "secrets", which
+	 * may be chosen randomly or administratively.
+	 * While a teamdctl "state dump" command contains all (json) details,
+	 * the "state view" command shows aggregator id,selected and state
+	 * info only, and omits the key and actor/partner lacpdu info too.
+	 */
+
+	/*
+	 * The aggregator id is an uint16_t (in bond rtnetlink), just json
+	 * has only one number type (parsed by _our_ json API to either an
+	 * int64_t or double C type).
+	 */
+	aggregator = ni_json_object_get_value(runner, "aggregator");
+	if (ni_json_int64_get(ni_json_object_get_value(aggregator, "id"), &i64))
+		lacp->aggregator.id = i64 >= 0 ? i64 : 0;
+
+	ni_json_bool_get(ni_json_object_get_value(runner, "selected"), &lacp->selected);
+	ni_json_string_get(ni_json_object_get_value(runner, "state"), &lacp->state);
+
+	return 0;
+}
+
+static int
+ni_teamd_state_port_runner_discover(ni_team_port_info_t *info, ni_json_t *port)
+{
+	ni_json_t *runner;
+
+	switch (info->runner.type) {
+	case NI_TEAM_RUNNER_LACP:
+		runner = ni_json_object_get_value(port, "runner");
+		ni_teamd_state_port_runner_lacp_discover(info, runner);
+		break;
+	default:
+		break;
+	}
+
+	return 0;
+}
+
+static int
+ni_teamd_state_port_watches_discover(ni_team_port_info_t *info, ni_json_t *port)
+{
+	ni_json_t *watches;
+
+	watches = ni_json_object_get_value(port, "link_watches");
+
+	/*
+	 * Currently, we don't show link_watch instance info details,
+	 * but just their summary / resulting "up" state only.
+	 */
+	ni_json_bool_get(ni_json_object_get_value(watches, "up"), &info->watches.up);
+
+	return 0;
+}
+
+static int
+ni_teamd_state_port_info_discover(ni_team_port_info_t *info, const char *name, ni_json_t *state)
+{
+	ni_json_t *port;
+
+	if ((port = ni_teamd_state_get_port_info(state, name))) {
+		if (ni_teamd_state_get_runner_type(state, &info->runner.type))
+			ni_teamd_state_port_runner_discover(info, port);
+		ni_teamd_state_port_watches_discover(info, port);
+	}
+	return 0;
+}
+
+extern int
+ni_teamd_port_info_discover(ni_netdev_port_info_t *info, const char *team, const char *name)
+{
+	ni_teamd_client_t *tdc = NULL;
+	ni_json_t *state = NULL;
+	char *jstr = NULL;
+
+	if (!info || ni_string_empty(team) || ni_string_empty(name))
+		return -1;
+
+	if (info->type != NI_IFTYPE_TEAM || !info->team)
+		return -1;
+
+	if (!(tdc = ni_teamd_client_open(team)))
+		goto failure;
+
+	if (ni_teamd_ctl_state_dump(tdc, &jstr) < 0)
+		goto failure;
+
+	if (!(state = ni_json_parse_string(jstr)))
+		goto failure;
+
+	ni_string_free(&jstr);
+
+	if (ni_teamd_state_port_info_discover(info->team, name, state) < 0)
+		goto failure;
+
+	ni_json_free(state);
+	ni_teamd_client_free(tdc);
+	return 0;
+
+failure:
+	ni_json_free(state);
+	ni_string_free(&jstr);
+	ni_teamd_client_free(tdc);
+	return -1;
+}
+
 /*
  * teamd startup config file
  */
diff --git a/src/teamd.h b/src/teamd.h
index e163e2ac7..56ab95e51 100644
--- a/src/teamd.h
+++ b/src/teamd.h
@@ -1,7 +1,7 @@
 /*
  *	Interfacing with teamd through dbus interface
  *
- *	Copyright (C) 2015 SUSE Linux GmbH, Nuernberg, Germany.
+ *	Copyright (C) 2015-2023 SUSE LLC
  *
  *	This program is free software; you can redistribute it and/or modify
  *	it under the terms of the GNU General Public License as published by
@@ -13,14 +13,8 @@
  *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *	GNU General Public License for more details.
  *
- *	You should have received a copy of the GNU General Public License along
- *	with this program; if not, see <http://www.gnu.org/licenses/> or write
- *	to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
- *	Boston, MA 02110-1301 USA.
- *
- *	Authors:
- *		Pawel Wieczorkiewicz <pwieczorkiewicz@suse.de>
- *		Marius Tomaschewski <mt@suse.de>
+ *	You should have received a copy of the GNU General Public License
+ *	along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef NI_TEAMD_CLIENT_H
 #define NI_TEAMD_CLIENT_H
@@ -41,11 +35,17 @@ extern int				ni_teamd_ctl_state_set_item(ni_teamd_client_t *, const char *,
 extern int				ni_teamd_ctl_port_add(ni_teamd_client_t *, const char *);
 extern int				ni_teamd_ctl_port_remove(ni_teamd_client_t *, const char *);
 extern int				ni_teamd_ctl_port_config_update(ni_teamd_client_t *, const char *, const char *);
+extern int				ni_teamd_ctl_port_config_dump(ni_teamd_client_t *, const char *, char **);
 
 extern int				ni_teamd_port_enslave(const ni_netdev_t *, const ni_netdev_t *, const ni_team_port_config_t *);
 extern int				ni_teamd_port_unenslave(const ni_netdev_t *, const ni_netdev_t *);
 
+extern int				ni_teamd_port_config_discover(ni_team_port_config_t *,
+								const char *, const char *);
+
 extern int				ni_teamd_discover(ni_netdev_t *);
+extern int				ni_teamd_port_info_discover(ni_netdev_port_info_t *,
+								const char *, const char *);
 
 extern int				ni_teamd_service_start(const ni_netdev_t *);
 extern int				ni_teamd_service_stop (const char *);
diff --git a/src/util.c b/src/util.c
index 50dfd97cf..1ae6b4f31 100644
--- a/src/util.c
+++ b/src/util.c
@@ -1552,6 +1552,20 @@ ni_string_set(char **pp, const char *value, size_t len)
 	return TRUE;
 }
 
+ni_bool_t
+ni_string_move(char **dst, char **src)
+{
+	if (!src || !dst)
+		return FALSE;
+
+	if (*dst)
+		free(*dst);
+	*dst = *src;
+	*src = NULL;
+
+	return TRUE;
+}
+
 const char *
 ni_string_printf(char **str, const char *fmt, ...)
 {
diff --git a/src/xml.c b/src/xml.c
index 59c31924b..4a5d20e78 100644
--- a/src/xml.c
+++ b/src/xml.c
@@ -1,7 +1,8 @@
 /*
  *	XML objects - document and node
  *
- *	Copyright (C) 2009-2012  Olaf Kirch <okir@suse.de>
+ *	Copyright (C) 2009-2012 Olaf Kirch <okir@suse.de>
+ *	Copyright (C) 2009-2023 SUSE LLC
  *
  *	This program is free software; you can redistribute it and/or modify
  *	it under the terms of the GNU General Public License as published by
@@ -13,11 +14,8 @@
  *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *	GNU General Public License for more details.
  *
- *	You should have received a copy of the GNU General Public License along
- *	with this program; if not, see <http://www.gnu.org/licenses/> or write 
- *	to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
- *	Boston, MA 02110-1301 USA.
- *
+ *	You should have received a copy of the GNU General Public License
+ *	along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
 #ifdef HAVE_CONFIG_H
 #include "config.h"
@@ -25,11 +23,12 @@
 
 #include <wicked/xml.h>
 #include <wicked/logging.h>
+#include "array_priv.h"
 #include "util_priv.h"
 #include <inttypes.h>
 
-#define XML_DOCUMENTARRAY_CHUNK		1
-#define XML_NODEARRAY_CHUNK		8
+#define XML_DOCUMENT_ARRAY_CHUNK	8
+#define XML_NODE_ARRAY_CHUNK		8
 
 xml_document_t *
 xml_document_new()
@@ -48,7 +47,7 @@ xml_document_root(xml_document_t *doc)
 }
 
 const char *
-xml_document_type(const xml_document_t *doc)
+xml_document_dtd(const xml_document_t *doc)
 {
 	return doc ? doc->dtd : NULL;
 }
@@ -84,6 +83,63 @@ xml_document_free(xml_document_t *doc)
 	}
 }
 
+xml_document_t *
+xml_document_create(const char *dtd, xml_node_t *root)
+{
+	xml_document_t *doc;
+
+	if ((doc = calloc(1, sizeof(*doc)))) {
+		if (ni_string_dup(&doc->dtd, dtd)) {
+			doc->root = root;
+			return doc;
+		}
+		xml_document_free(doc);
+	}
+	return NULL;
+}
+
+ni_bool_t
+xml_document_expand(xml_document_array_t *docs, xml_document_t *raw)
+{
+	ni_bool_t ret = TRUE;
+	xml_document_t *doc;
+	xml_node_t *node;
+	xml_node_t *next;
+
+	if (!docs || !raw || !raw->root)
+		return FALSE;
+
+	/*
+	 * Append if "raw" contains single named document root.
+	 */
+	if (!ni_string_empty(raw->root->name))
+		return xml_document_array_append(docs, raw);
+
+	/*
+	 * Otherwise, expand the just parsed data into multiple
+	 * "normalized" documents with one named root node each.
+	 */
+	for (node = raw->root->children; node; node = next) {
+		next = node->next;
+
+		if (ni_string_empty(node->name))
+			continue;
+
+		xml_node_detach(node);
+
+		if (!(doc = xml_document_create(raw->dtd, node)))
+			xml_node_free(node);
+		else if (!xml_document_array_append(docs, doc))
+			xml_document_free(doc);
+		else continue;
+
+		ret = FALSE;
+	}
+	if (ret)
+		xml_document_free(raw);
+	return ret;
+}
+
 /*
  * Helper functions for xml node list management
  */
@@ -308,79 +364,65 @@ xml_node_free(xml_node_t *node)
 	free(node);
 }
 
-void
+ni_bool_t
 xml_node_set_cdata(xml_node_t *node, const char *cdata)
 {
-	ni_string_dup(&node->cdata, cdata);
+	return ni_string_dup(&node->cdata, cdata);
 }
 
-void
+ni_bool_t
 xml_node_set_int(xml_node_t *node, int value)
 {
-	char buffer[32];
 
-	snprintf(buffer, sizeof(buffer), "%d", value);
-	ni_string_dup(&node->cdata, buffer);
+	return node && ni_string_printf(&node->cdata, "%d", value);
 }
 
-void
+ni_bool_t
 xml_node_set_int64(xml_node_t *node, int64_t value)
 {
-	char buffer[32];
-
-	snprintf(buffer, sizeof(buffer), "%"PRId64, value);
-	ni_string_dup(&node->cdata, buffer);
+	return node && ni_string_printf(&node->cdata, "%"PRId64, value);
 }
 
-void
+ni_bool_t
 xml_node_set_uint(xml_node_t *node, unsigned int value)
 {
-	char buffer[32];
-
-	snprintf(buffer, sizeof(buffer), "%u", value);
-	ni_string_dup(&node->cdata, buffer);
+	return node && ni_string_printf(&node->cdata, "%u", value);
 }
 
-void
+ni_bool_t
 xml_node_set_uint64(xml_node_t *node, uint64_t value)
 {
-	char buffer[32];
-
-	snprintf(buffer, sizeof(buffer), "%"PRIu64, value);
-	ni_string_dup(&node->cdata, buffer);
+	return node && ni_string_printf(&node->cdata, "%"PRIu64, value);
 }
 
-void
+ni_bool_t
 xml_node_set_uint_hex(xml_node_t *node, unsigned int value)
 {
-	char buffer[32];
-
-	snprintf(buffer, sizeof(buffer), "0x%x", value);
-	ni_string_dup(&node->cdata, buffer);
+	return node && ni_string_printf(&node->cdata, "0x%x", value);
 }
 
-void
+ni_bool_t
 xml_node_add_attr(xml_node_t *node, const char *name, const char *value)
 {
-	ni_var_array_set(&node->attrs, name, value);
+	return ni_var_array_set(&node->attrs, name, value);
 }
 
-void
+ni_bool_t
 xml_node_add_attr_uint(xml_node_t *node, const char *name, unsigned int value)
 {
-	ni_var_array_set_uint(&node->attrs, name, value);
+	return ni_var_array_set_uint(&node->attrs, name, value);
 }
 
-void
+ni_bool_t
 xml_node_add_attr_ulong(xml_node_t *node, const char *name, unsigned long value)
 {
-	ni_var_array_set_ulong(&node->attrs, name, value);
+	return ni_var_array_set_ulong(&node->attrs, name, value);
 }
 
-void
+ni_bool_t
 xml_node_add_attr_double(xml_node_t *node, const char *name, double value)
 {
-	ni_var_array_set_double(&node->attrs, name, value);
+	return ni_var_array_set_double(&node->attrs, name, value);
 }
 
 const ni_var_t *
@@ -471,12 +513,22 @@ xml_node_get_next_child(const xml_node_t *top, const char *name, const xml_node_
 	return NULL;
 }
 
-inline xml_node_t *
+xml_node_t *
 xml_node_get_child(const xml_node_t *node, const char *name)
 {
 	return xml_node_get_next_child(node, name, NULL);
 }
 
+const char *
+xml_node_get_child_cdata(const xml_node_t *node, const char *name)
+{
+	const xml_node_t *child;
+
+	if ((child = xml_node_get_child(node, name)))
+		return child->cdata;
+	return NULL;
+}
+
 /*
  * Find a child element given its name and a list of attributes
  */
@@ -720,85 +772,20 @@ xml_node_match_attrs(const xml_node_t *node, const ni_var_array_t *attrlist)
 /*
  * XML document arrays
  */
-void
-xml_document_array_init(xml_document_array_t *array)
-{
-	memset(array, 0, sizeof(*array));
-}
-
-void
-xml_document_array_destroy(xml_document_array_t *array)
-{
-	unsigned int i;
-
-	for (i = 0; i < array->count; ++i)
-		xml_document_free(array->data[i]);
-
-	if (array->data)
-		free(array->data);
-	memset(array, 0, sizeof(*array));
-}
-
-xml_document_array_t *
-xml_document_array_new(void)
-{
-	xml_document_array_t *array;
-
-	array = xcalloc(1, sizeof(*array));
-	return array;
-}
-
-void
-xml_document_array_free(xml_document_array_t *array)
-{
-	xml_document_array_destroy(array);
-	free(array);
-}
-
-static void
-__xml_document_array_realloc(xml_document_array_t *array, unsigned int newsize)
-{
-	xml_document_t **newdata;
-	unsigned int i;
-
-	newsize = (newsize + XML_DOCUMENTARRAY_CHUNK) + 1;
-	newdata = xrealloc(array->data, newsize * sizeof(xml_document_t *));
-
-	array->data = newdata;
-	for (i = array->count; i < newsize; ++i)
-		array->data[i] = NULL;
-}
-
-void
-xml_document_array_append(xml_document_array_t *array, xml_document_t *doc)
-{
-	if ((array->count % XML_DOCUMENTARRAY_CHUNK) == 0)
-		__xml_document_array_realloc(array, array->count);
-
-	array->data[array->count++] = doc;
-}
+extern ni_define_ptr_array_init(xml_document);
+extern ni_define_ptr_array_destroy(xml_document);
+static ni_define_ptr_array_realloc(xml_document, XML_DOCUMENT_ARRAY_CHUNK);
+extern ni_define_ptr_array_append(xml_document);
+extern ni_define_ptr_array_insert(xml_document);
+extern ni_define_ptr_array_index(xml_document);
 
 /*
  * XML node arrays
  */
-void
-xml_node_array_init(xml_node_array_t *array)
-{
-	memset(array, 0, sizeof(*array));
-}
-
-void
-xml_node_array_destroy(xml_node_array_t *array)
-{
-	unsigned int i;
-
-	for (i = 0; i < array->count; ++i)
-		xml_node_free(array->data[i]);
-
-	if (array->data)
-		free(array->data);
-	memset(array, 0, sizeof(*array));
-}
+extern ni_define_ptr_array_init(xml_node);
+extern ni_define_ptr_array_destroy(xml_node);
+static ni_define_ptr_array_realloc(xml_node, XML_NODE_ARRAY_CHUNK)
+extern ni_define_ptr_array_append(xml_node);
 
 xml_node_array_t *
 xml_node_array_new(void)
@@ -816,32 +803,6 @@ xml_node_array_free(xml_node_array_t *array)
 	free(array);
 }
 
-static void
-__xml_node_array_realloc(xml_node_array_t *array, unsigned int newsize)
-{
-	xml_node_t **newdata;
-	unsigned int i;
-
-	newsize = (newsize + XML_NODEARRAY_CHUNK) + 1;
-	newdata = xrealloc(array->data, newsize * sizeof(array->data[0]));
-
-	array->data = newdata;
-	for (i = array->count; i < newsize; ++i)
-		array->data[i] = NULL;
-}
-
-void
-xml_node_array_append(xml_node_array_t *array, xml_node_t *node)
-{
-	if (!array || !node)
-		return;
-
-	if ((array->count % XML_NODEARRAY_CHUNK) == 0)
-		__xml_node_array_realloc(array, array->count);
-
-	array->data[array->count++] = xml_node_clone_ref(node);
-}
-
 xml_node_t *
 xml_node_create(xml_node_t *parent, const char *name)
 {
diff --git a/testing/teamd-test.c b/testing/teamd-test.c
index d7e1dda55..3c5d7f78c 100644
--- a/testing/teamd-test.c
+++ b/testing/teamd-test.c
@@ -45,6 +45,8 @@ int main(int argc, char **argv)
 		rv = ni_teamd_ctl_config_dump(tdc, FALSE, &val);
 	else if (ni_string_eq(command, "config-dump-actual"))
 		rv = ni_teamd_ctl_config_dump(tdc, TRUE, &val);
+	else if (ni_string_eq(command, "port-config-dump"))
+		rv = ni_teamd_ctl_port_config_dump(tdc, param1, &val);
 
 	printf("%s\n", val ? val : ni_format_boolean(!!rv));
 
diff --git a/util/mkconst.c b/util/mkconst.c
index a5bedae16..be57481ce 100644
--- a/util/mkconst.c
+++ b/util/mkconst.c
@@ -22,6 +22,7 @@
 #include <wicked/logging.h>
 #include <wicked/wireless.h>
 #include <wicked/bonding.h>
+#include <wicked/bridge.h>
 #include <wicked/team.h>
 #include <wicked/route.h>
 #include <wicked/infiniband.h>
@@ -78,8 +79,9 @@ static struct generic_map	generic_maps[] = {
 	MAP(BONDING_AD_SELECT, ni_bonding_ad_select_name),
 	MAP(BONDING_FAIL_OVER_MAC, ni_bonding_fail_over_mac_name),
 	MAP(BONDING_PRIMARY_RESELECT, ni_bonding_primary_reselect_name),
-	MAP(BONDING_SLAVE_STATE, ni_bonding_slave_state_name),
-	MAP(BONDING_SLAVE_MII_STATUS, ni_bonding_slave_mii_status_name),
+	MAP(BONDING_PORT_STATE, ni_bonding_port_state_name),
+	MAP(BONDING_PORT_MII_STATUS, ni_bonding_port_mii_status_name),
+	MAP(BRIDGE_PORT_STATE, ni_bridge_port_state_name),
 	MAP(ROUTE_TYPE, ni_route_type_type_to_name),
 	MAP(ROUTE_PROTOCOL, ni_route_protocol_type_to_name),
 	MAPN(ROUTE_SCOPE, ni_route_scope_type_to_name, 256),
-- 
2.35.3

